unit hiFileVer;

interface

uses Share,Debug,KOL,Windows;

type
  THIFileVer = class(TDebug)
   private
     fv,pv:string;
     fVer:TVSFixedFileInfo;
     function GetFileVersion(AFileName:string): boolean;
   public
     _data_FileName:THI_Event;

     _event_onGetFileVersion:THI_Event;
     _event_onGetProductVersion:THI_Event;
     _event_onGetDebugBuild:THI_Event;
     _event_onGetPreRelease:THI_Event;
     _event_onGetPrivateBuild:THI_Event;
     _event_onGetSpecialBuild:THI_Event;
     _event_onGetPatched:THI_Event;
     _event_onGetInfoInferred:THI_Event;
     _event_onGetOS:THI_Event;
     _event_onGetFileType:THI_Event;

     procedure _work_doGetVersion(var _Data:TData; Index:word);

     procedure _var_FileVersion(var _Data:TData; Index:word);
     procedure _var_ProductVersion(var _Data:TData; Index:word);
  end;

implementation

function THIFileVer.GetFileVersion(AFileName:string): boolean;
var
  InfoSize, puLen: DWord;
  Pt, InfoPtr: Pointer;
begin
  InfoSize := GetFileVersionInfoSize(PChar(AFileName), puLen);
  fillchar( fVer, sizeof(TVSFixedFileInfo), 0);
  if InfoSize > 0 then
  begin
    GetMem(Pt,InfoSize);
    GetFileVersionInfo(PChar(AFileName), 0, InfoSize, Pt);
    VerQueryValue(Pt,'\',InfoPtr,puLen);
    move(InfoPtr^, fVer, sizeof(TVSFixedFileInfo));
    FreeMem(Pt);
    result := true;
  end else
    result := false;
end;
  
procedure THIFileVer._work_doGetVersion(var _Data:TData; Index:word);
var FN,os,ft:string;
    db,pr,pb,sb,pt,ii:integer;
begin
   FN := ReadString(_Data,_data_FileName,'');
  {if not} GetFileVersion(FN);// then _Debug; {then Exit else}
   begin
    fv := Format('%u.%u.%u.%u',[ // FileVersion
    HiWord(fVer.dwFileVersionMS),
    LoWord(fVer.dwFileVersionMS),
    HiWord(fVer.dwFileVersionLS),
    LoWord(fVer.dwFileVersionLS)]);

    pv := Format('%u.%u.%u.%u',[ // ProductVersion
    HiWord(fVer.dwProductVersionMS),
    LoWord(fVer.dwProductVersionMS),
    HiWord(fVer.dwProductVersionLS),
    LoWord(fVer.dwProductVersionLS)]);

    db := (fVer.dwFileFlagsMask and fVer.dwFileFlags and VS_FF_DEBUG);        // DebugBuild
    pr := (fVer.dwFileFlagsMask and fVer.dwFileFlags and VS_FF_PRERELEASE);   // PreRelease
    pb := (fVer.dwFileFlagsMask and fVer.dwFileFlags and VS_FF_PRIVATEBUILD); // PrivateBuild
    sb := (fVer.dwFileFlagsMask and fVer.dwFileFlags and VS_FF_SPECIALBUILD); // SpecialBuild
    pt := (fVer.dwFileFlagsMask and fVer.dwFileFlags and VS_FF_PATCHED);      // Patched
    ii := (fVer.dwFileFlagsMask and fVer.dwFileFlags and VS_FF_INFOINFERRED); // InfoInferred

    case fVer.dwFileOS of // OS
      VOS_DOS_WINDOWS16 : os := 'MS-DOS or 16 bit Windows';
      VOS_DOS_WINDOWS32 : os := '32 bit Windows';
      VOS_OS216_PM16 : os := '16 bit OS/2';
      VOS_OS232_PM32 : os := '32 bit OS/2';
      VOS_NT_WINDOWS32 : os := 'Win32 or Windows NT';
      else os := 'Unknown OS';
    end;

  ft := ''; // FileType
    case fVer.dwFileType of
      VFT_APP : ft := 'Application';
      VFT_DLL : ft := 'Dynamic Link Library (DLL)';
      VFT_DRV :
        begin
          ft := 'Device Driver - ';
          case fVer.dwFileSubtype of
            VFT2_DRV_PRINTER :     ft := ft + 'Printer';
            VFT2_DRV_KEYBOARD :    ft := ft + 'Keyboard';
            VFT2_DRV_LANGUAGE :    ft := ft + 'Language';
            VFT2_DRV_DISPLAY :     ft := ft + 'Display';
            VFT2_DRV_MOUSE :       ft := ft + 'Mouse';
            VFT2_DRV_NETWORK :     ft := ft + 'Network';
            VFT2_DRV_SYSTEM :      ft := ft + 'System';
            VFT2_DRV_INSTALLABLE : ft := ft + 'Installable';
            VFT2_DRV_SOUND :       ft := ft + 'Sound';
            VFT2_DRV_COMM :        ft := ft + 'Communications';
            else ft := ft + 'Unknown';
          end;
        end;
      VFT_FONT :
        begin
          ft := 'Font File - ';
          case fVer.dwFileSubType of
            VFT2_FONT_RASTER :   ft := ft + 'Raster';
            VFT2_FONT_VECTOR :   ft := ft + 'Vector';
            VFT2_FONT_TRUETYPE : ft := ft + 'TrueType';
            else ft := ft + 'Unknown';
          end;
        end;
      VFT_VXD :        ft := 'Virtual Device';
      VFT_STATIC_LIB : ft := 'Static-link Library'
      else ft := 'Unknown File Type';
    end;
   end;  
   _hi_OnEvent(_event_onGetFileVersion,fv); 
   _hi_OnEvent(_event_onGetProductVersion,pv);   
   _hi_OnEvent(_event_onGetDebugBuild,db);
   _hi_OnEvent(_event_onGetPreRelease,pr);
   _hi_OnEvent(_event_onGetPrivateBuild,pb);
   _hi_OnEvent(_event_onGetSpecialBuild,sb);
   _hi_OnEvent(_event_onGetPatched,pt);
   _hi_OnEvent(_event_onGetInfoInferred,ii);   
   _hi_OnEvent(_event_onGetOS,os);
   _hi_OnEvent(_event_onGetFileType,ft);
end;

procedure THIFileVer._var_FileVersion;
begin
   dtString(_data, fv);
end;

procedure THIFileVer._var_ProductVersion;
begin
   dtString(_data, pv);
end;

end.